\chapter{Baseline Many-Core Exploration Platform} \label{chapt:core}
%
%
\vskip 1cm
%
%
This Chapter presents the baseline heterogeneous system used in this dissertation to evaluate, test and validate our proposed solutions. The nu$+$ many-core is a modular and deeply customizable system based on a regular mesh network-on-chip of configurable tiles, designed to be an extensible and parametric platform from the ground up suitable for exploring advanced architectural solutions. Developed in the framework of the MANGO FETHPC project, the main objective of nu+ is to enable resource-efficient HPC based on special-purpose customized hardware. This led to a modular design and an instruction layout that exposes enough freedom to extend both the standard set of instructions and the baseline nu+ hardware design, hereafter discussed. This project aims to pose a fully customizable and easy to extend many-core system, suitable for the exploration of both software and hardware advanced solutions for tomorrow's systems. 
The following Chapters describe the baseline many-core system in a top-down way, starting with an overview of the nu+ tile. The current Chapter focuses on the baseline multi-threaded core, the hearth of the calculation part, and on the NoC-based networking subsystem, while the next Chapter details the coherence subsystem.

\section{Tile Overview}
Figure \ref{fig:manycore} captures a simplified overview of the nu+ many-core. Each nu+ tile has the same basic components, it provides a configurable GPU-like accelerator meant to be used as a configurable FPGA overlay, an extendible coherence subsystem protocol independent, and a mesh-based networking system which routes hardware messages over the communication network. 

The accelerator merges the SIMT paradigm with vector processor model. The GPU-like model exposes promising features for improved resource efficiency. In fact, it provides hardware threads executing coupled with SIMD execution units, while reducing control overheads and hiding possibly long latencies. This accelerator effectively exploits multi-threading, SIMD operations, and low-overhead control flow constructs, in addition to a range of advanced architecture customization capabilities, in order to enable a high-level utilization of the underlying resources. Furthermore, each tile is equipped with both a \texttt{Cache Controller} and a \texttt{Directory Controller}, these handle data coherence among different cores in different tiles, providing a transparent sharing memory programming model to the software developer.

\begin{figure}[t]
	\centering
	\includegraphics[width=0.99\textwidth]{Chapters/Arch/figures/nuplus_manycore.eps}
	\caption{The nu+ many-core overview.}
	\label{fig:manycore}
\end{figure}


\section{Design principles}

The MANGO project set a few baseline features for the GPU-like accelerator, which included: 

\begin{enumerate}
	\item Support for hardware multithreading and data-level parallelism through large-size vector/SIMD/SIMT support.
	\item Multi-/many-core organization allowing non-SIMT execution.
	\item Lightweight control flow constructs exposed to the programmer, such as predication and mechanisms for optimizing diverging threads and improving datapath utilization,
	\item Hybrid memory hierarchy providing both coherent caches and non-coherent scratch-pad memory.
	\item On-tile performance counters.
\end{enumerate}

Notice that, in line with the main strategic objectives of this dissertation towards the support of broad-spectrum architecture exploration, the baseline architecture activities described in these Chapters aimed at releasing a platform for the instantiation and evaluation of all of the above features, rather than focusing on the specific implementation/optimization of any of them. 

\input{Chapters/Arch/core.tex}
\input{Chapters/Arch/networking.tex}










